#include <config.h>

#include <assert.h>

#include <stdlib.h>
#include <options.h>
#include <pagetable.h>
#include <physmem.h>
#include <simulate.h>
#include <stats.h>
#include <input.h>
#include <fault.h>
#include <util.h>

static void init();
static void test();

int main(int argc, char **argv) {
  options_process(argc, argv);
  if (opts.test) {
    test();
    printf("Tests done.\n");
    exit(0);
  }
  
  init();

  simulate();

  stats_output();
  
  return 0;
}

void init() {   
  pagetable_init();
  physmem_init();
  stats_init();
  fault_init();
  input_init(opts.input_file);
}

void test() {
  printf("Running vmtrace tests...\n");
  util_test();
  stats_init();
  pagetable_test();
}
